Index: squid/src/store_dir.c
diff -u squid/src/store_dir.c:1.1.1.2 squid/src/store_dir.c:1.1.1.2.10.1
--- squid/src/store_dir.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/store_dir.c	Fri Nov 10 10:44:53 2000
@@ -39,9 +39,10 @@
 #include <sys/statvfs.h>
 #endif
 #endif
+#ifdef MMAPSTORE
+#include <sys/mman.h>
+#endif
 
-#define SWAP_DIR_SHIFT 24
-#define SWAP_FILE_MASK 0x00FFFFFF
 #define DefaultLevelOneDirs     16
 #define DefaultLevelTwoDirs     256
 
@@ -232,16 +233,20 @@
 static int
 storeDirSelectSwapDir(void)
 {
-    double least_used = 1.0;
-    double high = (double) Config.Swap.highWaterMark / 100.0;
-    double u;
-    int dirn;
     int i, j;
-    SwapDir *SD;
-    static int nleast = 0;
-    static int nconf = 0;
+    static unsigned nleast = 0;
+    static unsigned returnlast = 0;
+    static unsigned nconf = 0;
+    static unsigned lastdirn;
+    static unsigned relstoremax;
     static int *dirq = NULL;
-    static double *diru = NULL;
+    static unsigned long *diru = NULL;
+    unsigned long least_used;
+    /*
+     * Scan for a non-negative dirn in the dirq array and return that one
+     */
+    if (returnlast)
+	return dirq[--returnlast];
     /*
      * Handle simplest case of a single swap directory immediately
      */
@@ -256,45 +261,28 @@
 	safe_free(dirq);
 	dirq = (int *) xmalloc(sizeof(int) * nleast);
 	safe_free(diru);
-	diru = (double *) xmalloc(sizeof(double) * nconf);
+	diru = xmalloc(sizeof*diru * nconf);
 	for (j = 0; j < nleast; j++)
 	    dirq[j] = -1;
+	relstoremax = ((unsigned)Config.Swap.highWaterMark*2 + 1) *
+	 STORE_GRAN_MAX / 200 + 1;
     }
     /*
-     * Scan for a non-negative dirn in the dirq array and return that one
-     */
-    dirn = -1;
-    for (j = 0; j < nleast; j++) {
-	dirn = dirq[j];
-	if (dirn < 0)
-	    continue;
-	dirq[j] = -1;
-	break;
-    }
-    /*
-     * If we found a valid dirn return it
-     */
-    if (dirn >= 0)
-	return dirn;
-    /*
      * Now for the real guts of the algorithm - building the dirq array
      */
     for (i = 0; i < nconf; i++) {
-	diru[i] = 1.1;
-	SD = &Config.cacheSwap.swapDirs[i];
+        SwapDir *SD = &Config.cacheSwap.swapDirs[i];
+	diru[i] = STORE_GRAN_MAX+STORE_GRAN_MAX/2;
 	SD->flags.selected = 0;
 	if (SD->flags.read_only)
 	    continue;
-	u = (double) SD->cur_size / SD->max_size;
-	if (u > high)
-	    continue;
-	diru[i] = u;
+	diru[i] = SD->cur_size/
+	 (((unsigned long)SD->max_size+STORE_GRAN_MAX-1)>>STORE_GRAN_ORDER);
     }
     for (j = 0; j < nleast; j++) {
-	dirq[j] = -1;
-	least_used = 1.0;
-	dirn = -1;
-	for (i = 0; i < nconf; i++) {
+        int dirn = -1;
+	least_used = relstoremax;
+	for (i = lastdirn; (i = (i+1)%nconf) != lastdirn; ) {
 	    if (diru[i] < least_used) {
 		least_used = diru[i];
 		dirn = i;
@@ -302,19 +290,25 @@
 	}
 	if (dirn < 0)
 	    break;
-	dirq[j] = dirn;
-	diru[dirn] = 1.1;
+	dirq[j] = lastdirn = dirn;
+	diru[dirn] = STORE_GRAN_MAX+2;
 	/* set selected flag for debugging/cachemgr only */
 	Config.cacheSwap.swapDirs[dirn].flags.selected = 1;
     }
+    if (!j)
+	for (i = nconf; i--;)
+	    if (diru[i] == least_used) {
+		dirq[j] = i;
+		Config.cacheSwap.swapDirs[i].flags.selected = 1;
+		if (++j == nleast)
+		    break;
+    }
     /*
      * Setup default return of 0 if no least found
      */
-    if (dirq[0] < 0)
-	dirq[0] = 0;
-    dirn = dirq[0];
-    dirq[0] = -1;
-    return dirn;
+    if (!j)
+	return 0;
+    return dirq[returnlast = j-1];
 }
 
 int
@@ -386,6 +380,185 @@
     return (dirn << SWAP_DIR_SHIFT) | (fn & SWAP_FILE_MASK);
 }
 
+static struct mmapinfo *allmi;
+
+static void
+mapfdswap(SwapDir *sd)
+{
+#ifdef MMAPSTORE
+    struct stat stbuf;
+    struct mmapinfo *mi = sd->mi;
+    if (!mi) {
+	const char *path = sd->path;
+	for (mi = allmi; ; mi = mi->next) {
+	    if (!mi) {
+		mi = xmalloc(sizeof *mi);
+		mi->next = allmi;
+		allmi = mi;
+		mi->path = xstrdup(path);
+		mi->mmapbase = mi->mmapfreelist = 0;
+		break;
+	    }
+	    if (!strcmp(mi->path, path))
+		break;
+	}
+	sd->mi = mi;
+    }
+    if(mi->mmapbase)
+	munmap(mi->mmapbase, (char*)mi->mmapmax-(char*)mi->mmapbase);
+    if(!fstat(sd->swaplog_fd,&stbuf)) {
+	storeSwapLogData*oldbase = mi->mmapbase, *oldend = mi->mmapend;
+	size_t max=(((size_t)stbuf.st_size/16*17+32768)/sizeof*mi->mmapbase+1)*
+	    sizeof*mi->mmapbase;
+	if(MAP_FAILED != (mi->mmapbase = mmap(0, max, PROT_READ|PROT_WRITE,
+	    MAP_SHARED, sd->swaplog_fd, 0))) {
+	    mi->mmapend = mi->mmapbase + stbuf.st_size/sizeof*mi->mmapbase;
+	    mi->mmapmax = (storeSwapLogData*)((char*)mi->mmapbase + max);
+	    if (oldbase) {
+	        ptrdiff_t fix = (char*)mi->mmapbase-(char*)oldbase;
+#ifdef	HPL_REPL
+		int node;
+	        for (node=0; node < heap_nodes(sd->heap); node++) {
+	            StoreEntry *e = (StoreEntry*)heap_peep(sd->heap, node);
+#else	/* HPL_REPL */
+		dlink_node *m;
+	        for (m = store_list.tail; m; m = m->prev) {
+	            StoreEntry *e = m->data;
+	            if (oldbase <= e->s && e->s <oldend)
+#endif	/* HPL_REPL */
+		        e->s = (storeSwapLogData*)((char*)e->s+fix);
+	        }
+		if(mi->mmapfreelist)
+		    mi->mmapfreelist =
+			(storeSwapLogData*)((char*)mi->mmapfreelist+fix);
+	    }
+	    return;
+	}
+    } else
+	sd->mi = 0;
+    fatal_dump("mapfdswap: Couldn't mmap() the store swap logfiles\n");
+    return;
+#endif
+}
+
+void storeSwapToFreeList(SwapDir*sd, storeSwapLogData *s)
+{
+    struct mmapinfo *mi = sd->mi;
+    s->swap_file_number = -1;
+    if (mi->mmapend != s+1) {
+	s->swap_file_sz = mi->mmapfreelist ? mi->mmapfreelist - s : 0 ;
+	mi->mmapfreelist = s;
+    } else {
+	int ret;
+	ret = ftruncate (sd->swaplog_fd, (char*)s - (char*)mi->mmapbase);
+	lseek (sd->swaplog_fd, 0L, SEEK_END);
+	assert(!ret);
+	mi->mmapend--;
+    }
+}
+
+storeSwapLogData*storeSwapAppendList(SwapDir*sd, storeSwapLogData*s)
+{
+    struct mmapinfo *mi = sd->mi;
+    {
+        storeSwapLogData*ns;
+        if (ns = mi->mmapfreelist) {
+	    mi->mmapfreelist = ns->swap_file_sz ?
+		ns + (int)ns->swap_file_sz : 0;
+	    *ns = *s;
+	    return ns;
+        }
+    }
+    if(mi->mmapend == mi->mmapmax)
+	mapfdswap(sd);
+    {
+	int ret, todo=sizeof*s;
+	char*p = (char*)s;
+	do
+	    ret = write(sd->swaplog_fd, p, todo);
+	while (ret < 0 && (errno == EAGAIN || errno == EINTR) ||
+	    (p += ret, todo -= ret));
+	if ( ret <= 0 )
+            debug(20, 0) ("storeSwapAppendList: %d %d\n", ret, errno);
+	assert(ret > 0);
+    }
+    return mi->mmapend++;
+}
+
+SwapDir*
+getswapdir(int swapfilenumber)
+{
+    unsigned dirn = (swapfilenumber >> SWAP_DIR_SHIFT);
+    assert(dirn < Config.cacheSwap.n_configured);
+    return Config.cacheSwap.swapDirs + dirn;
+}
+
+void
+destroy_storeSwapLogData(storeSwapLogData*s)
+{
+#ifdef MMAPSTORE
+    int swf = s->swap_file_number;
+    if (swf < 0)
+#endif
+	memFree(s, MEM_STORESWAPLOGDATA);
+#ifdef MMAPSTORE
+    else
+	storeSwapToFreeList(getswapdir(swf), s);
+#endif
+}
+
+void
+set_swap_file_number(StoreEntry*e, int swf)
+{
+#ifdef MMAPSTORE
+    storeSwapLogData*s = e->s;
+    int oswf = s->swap_file_number;
+    if (oswf == swf)
+	return;
+    if (shutting_down) {
+	if (oswf >= 0) {
+            storeSwapLogData *ns = memAllocate(MEM_STORESWAPLOGDATA);
+	    *ns = *s;
+	    e->s = ns;
+	}
+        s->swap_file_number = swf;
+	return;
+    }
+    s->swap_file_number = swf;
+    if (EBIT_TEST(e->Sflag, ENTRY_SPECIAL))
+	return;
+    if (oswf < 0) {
+        SwapDir*sd = getswapdir(swf);
+	e->s = storeSwapAppendList(sd, s);
+	memFree(s, MEM_STORESWAPLOGDATA);
+#if HPL_REPL
+	assert(e->n.ode.id < 0);
+	heap_insert(sd->heap, e);
+#endif
+    } else {
+        SwapDir*sd,*osd = getswapdir(oswf);
+        if (swf < 0) {
+            storeSwapLogData *ns = memAllocate(MEM_STORESWAPLOGDATA);
+	    *ns = *s;
+	    e->s = ns;
+	    goto takeout;
+        }
+	sd = getswapdir(swf);
+	if (sd != osd) {
+	    e->s = storeSwapAppendList(sd, s);
+takeout:
+#if HPL_REPL
+	    if (e->n.ode.id >= 0) {
+		heap_delete(osd->heap, &e->n.ode);
+		e->n.ode.id = -1;
+	    }
+#endif
+	    storeSwapToFreeList(osd, s);
+	}
+    }
+#endif
+}
+
 /*
  * An entry written to the swap log MUST have the following
  * properties.
@@ -396,42 +569,48 @@
  *   2.  It MUST have a valid (> -1) swap_file_number.
  */
 void
-storeDirSwapLog(const StoreEntry * e, int op)
+storeDirSwapLog(StoreEntry * e, int op)
 {
+#ifdef MMAPSTORE
+    return;
+#else
     storeSwapLogData *s;
     int dirn;
-    dirn = e->swap_file_number >> SWAP_DIR_SHIFT;
+    SwapDir*sd;
+    dirn = e->Sswap_file_number >> SWAP_DIR_SHIFT;
     assert(dirn < Config.cacheSwap.n_configured);
-    assert(!EBIT_TEST(e->flags, KEY_PRIVATE));
-    assert(e->swap_file_number >= 0);
+    assert(!EBIT_TEST(e->Sflag, KEY_PRIVATE));
+    assert(e->Sswap_file_number >= 0);
+    sd = &Config.cacheSwap.swapDirs[dirn];
     /*
      * icons and such; don't write them to the swap log
      */
-    if (EBIT_TEST(e->flags, ENTRY_SPECIAL))
+    if (EBIT_TEST(e->Sflag, ENTRY_SPECIAL))
 	return;
     assert(op > SWAP_LOG_NOP && op < SWAP_LOG_MAX);
     debug(20, 3) ("storeDirSwapLog: %s %s %08X\n",
 	swap_log_op_str[op],
-	storeKeyText(e->key),
-	e->swap_file_number);
+	storeKeyText(e->Skey),
+	e->Sswap_file_number);
     s = xcalloc(1, sizeof(storeSwapLogData));
     s->op = (char) op;
-    s->swap_file_number = e->swap_file_number;
-    s->timestamp = e->timestamp;
-    s->lastref = e->lastref;
-    s->expires = e->expires;
-    s->lastmod = e->lastmod;
-    s->swap_file_sz = e->swap_file_sz;
-    s->refcount = e->refcount;
-    s->flags = e->flags;
+    s->timestamp = e->Stimestamp;
+    s->lastref = e->Slastref;
+    s->expires = e->Sexpires;
+    s->lastmod = e->Slastmod;
+    s->swap_file_sz = e->Sswap_file_sz;
+    s->refcount = e->Srefcount;
+    s->flags = e->Sflag;
     xmemcpy(s->key, e->key, MD5_DIGEST_CHARS);
-    file_write(Config.cacheSwap.swapDirs[dirn].swaplog_fd,
+    s->swap_file_number = e->Sswap_file_number;
+    file_write(sd->swaplog_fd,
 	-1,
 	s,
 	sizeof(storeSwapLogData),
 	NULL,
 	NULL,
 	xfree);
+#endif
 }
 
 char *
@@ -463,14 +642,88 @@
     for (i = 0; i < Config.cacheSwap.n_configured; i++) {
 	SD = &Config.cacheSwap.swapDirs[i];
 	path = storeDirSwapLogFile(i, NULL);
-	fd = file_open(path, O_WRONLY | O_CREAT, NULL, NULL, NULL);
+	fd = file_open(path, O_RDWR | O_CREAT, NULL, NULL, NULL);
 	if (fd < 0) {
 	    debug(50, 1) ("%s: %s\n", path, xstrerror());
 	    fatal("storeDirOpenSwapLogs: Failed to open swap log.");
+#ifdef MMAPSTORE
+	    SD->mi = 0;
+#endif
 	}
 	debug(47, 3) ("Cache Dir #%d log opened on FD %d\n", i, fd);
 	SD->swaplog_fd = fd;
+	lseek(fd, 0L, SEEK_END);
+	mapfdswap(SD);
+#if HPL_REPL
+	if (!SD->heap)
+	    SD->heap = new_heap(SD->max_size / Config.Store.avgObjectSize,
+			    store_policy,
+			    offsetof(StoreEntry, n.ode));
+#endif
     }
+#ifdef MMAPSTORE
+    {
+	struct mmapinfo *mi, **pmi;
+	for (pmi=&allmi; mi = *pmi; ) {
+	    for (i = 0; i < Config.cacheSwap.n_configured; i++) {
+		SD = &Config.cacheSwap.swapDirs[i];
+		if (SD->swaplog_fd < 0)	/* not open */
+		    continue;
+		if (SD->mi == mi) {
+		    pmi = &mi->next;
+		    goto next;
+		}
+	    }
+	    xfree(mi->path);
+	    *pmi = mi->next;
+	    {
+		storeSwapLogData*oldbase = mi->mmapbase, *oldend = mi->mmapend;
+#ifdef	HPL_REPL
+#if 1
+		assert(0); /* delete_heap, filebitmap */
+#else
+		heap_node_p tobefreed = 0;
+		int node;
+	        for (node=0; node < heap_nodes(store_heap); ) {
+	            StoreEntry *e = (StoreEntry*)heap_peep(store_heap, node);
+	            if (oldbase <= e->s && e->s <oldend) {
+		 	heap_node_p tp;
+			tp = tobefreed;
+			tobefreed = e->n.ode;
+			e->n.ode = tp;		/* collect'm */
+			continue;
+		    }
+		    node++;
+	        }
+		while (tobefreed) {		/* delete'm */
+		    heap_node_p next;
+		    StoreEntry *e;
+		    e = tobefreed->data;
+		    next = e->n.ode;
+		    e->n.ode = tobefreed;	/* put back node value */
+		    storeHashDelete(e);
+		    tobefreed = next;
+		}
+#endif
+#else	/* HPL_REPL */
+		dlink_node *m;
+	        for (m = store_list.tail; m; ) {
+	            StoreEntry *e = m->data;
+		    m = m->prev;
+	            if (oldbase <= e->s && e->s <oldend) {
+		        storeHashDelete(e);
+			continue;
+		    }
+    }
+#endif	/* HPL_REPL */
+	    }
+	    munmap(mi->mmapbase, (char*)mi->mmapmax-(char*)mi->mmapbase);
+	    xfree(mi);
+next:;
+	}
+    }
+#endif
+
 }
 
 void
@@ -482,6 +735,13 @@
 	SD = &Config.cacheSwap.swapDirs[i];
 	if (SD->swaplog_fd < 0)	/* not open */
 	    continue;
+#ifdef MMAPSTORE
+	{
+	    struct mmapinfo *mi = SD->mi;
+	    msync(mi->mmapbase, (char*)mi->mmapend-(char*)mi-> mmapbase, MS_ASYNC);
+	}
+	SD->mi = 0;
+#endif
 	file_close(SD->swaplog_fd);
 	debug(47, 3) ("Cache Dir #%d log closed on FD %d\n", i, SD->swaplog_fd);
 	SD->swaplog_fd = -1;
@@ -491,6 +751,10 @@
 FILE *
 storeDirOpenTmpSwapLog(int dirn, int *clean_flag, int *zero_flag)
 {
+#ifdef MMAPSTORE
+    *clean_flag = 1; *zero_flag = 0;
+    return stderr;
+#else
     char *swaplog_path = xstrdup(storeDirSwapLogFile(dirn, NULL));
     char *clean_path = xstrdup(storeDirSwapLogFile(dirn, ".last-clean"));
     char *new_path = xstrdup(storeDirSwapLogFile(dirn, ".new"));
@@ -535,11 +799,13 @@
     safe_free(clean_path);
     safe_free(new_path);
     return fp;
+#endif
 }
 
 void
 storeDirCloseTmpSwapLog(int dirn)
 {
+#ifndef MMAPSTORE
     char *swaplog_path = xstrdup(storeDirSwapLogFile(dirn, NULL));
     char *new_path = xstrdup(storeDirSwapLogFile(dirn, ".new"));
     SwapDir *SD = &Config.cacheSwap.swapDirs[dirn];
@@ -564,6 +830,7 @@
     safe_free(new_path);
     SD->swaplog_fd = fd;
     debug(47, 3) ("Cache Dir #%d log opened on FD %d\n", dirn, fd);
+#endif
 }
 
 void
@@ -600,13 +867,23 @@
     for (i = 0; i < Config.cacheSwap.n_configured; i++) {
 	SD = &Config.cacheSwap.swapDirs[i];
 	storeAppendPrintf(sentry, "\n");
-	storeAppendPrintf(sentry, "Store Directory #%d: %s\n", i, SD->path);
-	storeAppendPrintf(sentry, "First level subdirectories: %d\n", SD->l1);
-	storeAppendPrintf(sentry, "Second level subdirectories: %d\n", SD->l2);
-	storeAppendPrintf(sentry, "Maximum Size: %d KB\n", SD->max_size);
-	storeAppendPrintf(sentry, "Current Size: %d KB\n", SD->cur_size);
-	storeAppendPrintf(sentry, "Percent Used: %0.2f%%\n",
-	    100.0 * SD->cur_size / SD->max_size);
+	storeAppendPrintf(sentry, "Store Directory #%d: %s [%d][%d]\n",
+	    i, SD->path, SD->l1, SD->l2);
+	storeAppendPrintf(sentry, "Size: %d < %d < %d KB of %d MB (%.2f%%)\n",
+	    SD->low_size, SD->cur_size, SD->low_size + SD->win_size*STORE_GRAN_MAX,
+	    SD->max_size / 1024, 100.0 * SD->cur_size / SD->max_size);
+#ifdef MMAPSTORE
+	{
+	    struct mmapinfo *mi = SD->mi;
+	    storeAppendPrintf(sentry,
+		"Swapfile: %.1f < %.1f < %.1f MB (%.2f%% efficiency)\n",
+		SD->heap->last * sizeof(storeSwapLogData) / (1024*1024.),
+		((char*)mi->mmapend-(char*)mi->mmapbase) / (1024*1024.),
+		((char*)mi->mmapmax-(char*)mi->mmapbase) / (1024*1024.),
+		100. * (SD->heap->last * sizeof(storeSwapLogData)) /
+		  ((char*)mi->mmapend-(char*)mi->mmapbase));
+	}
+#endif
 	storeAppendPrintf(sentry, "Filemap bits in use: %d of %d (%d%%)\n",
 	    SD->map->n_files_in_map, SD->map->max_n_files,
 	    percent(SD->map->n_files_in_map, SD->map->max_n_files));
@@ -643,6 +920,50 @@
     return n;
 }
 
+
+void
+storeDirConfigure(void)
+{
+    SwapDir *SD;
+    int n;
+    int i;
+    fileMap *fm;
+    Config.Swap.maxSize = 0;
+    for (i = 0; i < Config.cacheSwap.n_configured; i++) {
+	SD = &Config.cacheSwap.swapDirs[i];
+	Config.Swap.maxSize += SD->max_size;
+	SD->low_size = (double) SD->max_size * Config.Swap.lowWaterMark /100;
+	SD->win_size = (double) SD->max_size *
+		(Config.Swap.highWaterMark - Config.Swap.lowWaterMark) /100
+		/STORE_GRAN_MAX;
+	if (!SD->win_size)
+	    SD->win_size = 1;
+	n = SD->max_size / Config.Store.avgObjectSize * 3 / 2;
+	if (NULL == SD->map) {
+	    /* first time */
+	    SD->map = file_map_create(n);
+	    SD->heap = 0;
+	} else if (n > SD->map->max_n_files) {
+	    /* it grew, need to expand */
+	    fm = file_map_create(n);
+	    filemapCopy(SD->map, fm);
+	    filemapFreeMemory(SD->map);
+	    SD->map = fm;
+	}
+	/* else it shrunk, and we leave the old one in place */
+    }
+}
+
+void
+storeDirDiskFull(int fn)
+{
+    int dirn = fn >> SWAP_DIR_SHIFT;
+    SwapDir *SD = &Config.cacheSwap.swapDirs[dirn];
+    assert(0 <= dirn && dirn < Config.cacheSwap.n_configured);
+    SD->max_size = SD->cur_size;
+    debug(20, 1) ("WARNING: Shrinking cache_dir #%d to %d KB\n",
+	dirn, SD->cur_size);
+}
 /*
  *  storeDirWriteCleanLogs
  * 
@@ -652,6 +973,9 @@
 int
 storeDirWriteCleanLogs(int reopen)
 {
+#ifdef MMAPSTORE
+    return 0;
+#else
     StoreEntry *e = NULL;
     int *fd;
     int n = 0;
@@ -662,11 +986,16 @@
     char **cln;
     int dirn;
     int N = Config.cacheSwap.n_configured;
-    dlink_node *m;
     char **outbuf;
     off_t *outbufoffset;
     storeSwapLogData s;
     size_t ss = sizeof(storeSwapLogData);
+    #ifdef	HPL_REPL
+    int node;
+    #else	/* HPL_REPL */
+    dlink_node *m;
+    #endif	/* HPL_REPL */
+
     if (store_rebuilding) {
 	debug(20, 1) ("Not currently OK to rewrite swap log.\n");
 	debug(20, 1) ("storeDirWriteCleanLogs: Operation aborted.\n");
@@ -707,34 +1036,43 @@
 	outbuf[dirn] = xcalloc(CLEAN_BUF_SZ, 1);
 	outbufoffset[dirn] = 0;
     }
-    for (m = store_list.tail; m; m = m->prev) {
+    #ifdef	HPL_REPL
+    for (node=0; node < heap_nodes(store_heap); node++)
+    #else	/* HPL_REPL */
+    for (m = store_list.tail; m; m = m->prev)
+    #endif	/* HPL_REPL */
+      {
+	#ifdef	HPL_REPL
+	e = (StoreEntry*)heap_peep(store_heap, node);
+	#else	/* HPL_REPL */
 	e = m->data;
-	if (e->swap_file_number < 0)
+	#endif	/* HPL_REPL */
+	if (e->Sswap_file_number < 0)
 	    continue;
 	if (e->swap_status != SWAPOUT_DONE)
 	    continue;
-	if (e->swap_file_sz <= 0)
+	if (e->Sswap_file_sz <= 0)
 	    continue;
-	if (EBIT_TEST(e->flags, RELEASE_REQUEST))
+	if (EBIT_TEST(e->Sflag, RELEASE_REQUEST))
 	    continue;
-	if (EBIT_TEST(e->flags, KEY_PRIVATE))
+	if (EBIT_TEST(e->Sflag, KEY_PRIVATE))
 	    continue;
-	if (EBIT_TEST(e->flags, ENTRY_SPECIAL))
+	if (EBIT_TEST(e->Sflag, ENTRY_SPECIAL))
 	    continue;
-	dirn = storeDirNumber(e->swap_file_number);
+	dirn = storeDirNumber(e->Sswap_file_number);
 	assert(dirn < N);
 	if (fd[dirn] < 0)
 	    continue;
 	memset(&s, '\0', ss);
 	s.op = (char) SWAP_LOG_ADD;
-	s.swap_file_number = e->swap_file_number;
-	s.timestamp = e->timestamp;
-	s.lastref = e->lastref;
-	s.expires = e->expires;
-	s.lastmod = e->lastmod;
-	s.swap_file_sz = e->swap_file_sz;
-	s.refcount = e->refcount;
-	s.flags = e->flags;
+	s.swap_file_number = e->Sswap_file_number;
+	s.timestamp = e->Stimestamp;
+	s.lastref = e->Slastref;
+	s.expires = e->Sexpires;
+	s.lastmod = e->Slastmod;
+	s.swap_file_sz = e->Sswap_file_sz;
+	s.refcount = e->Srefcount;
+	s.flags = e->Sflag;
 	xmemcpy(&s.key, e->key, MD5_DIGEST_CHARS);
 	xmemcpy(outbuf[dirn] + outbufoffset[dirn], &s, ss);
 	outbufoffset[dirn] += ss;
@@ -828,42 +1166,6 @@
     safe_free(cln);
     safe_free(fd);
     return n;
+#endif
 }
 #undef CLEAN_BUF_SZ
-
-void
-storeDirConfigure(void)
-{
-    SwapDir *SD;
-    int n;
-    int i;
-    fileMap *fm;
-    Config.Swap.maxSize = 0;
-    for (i = 0; i < Config.cacheSwap.n_configured; i++) {
-	SD = &Config.cacheSwap.swapDirs[i];;
-	Config.Swap.maxSize += SD->max_size;
-	n = 2 * SD->max_size / Config.Store.avgObjectSize;
-	if (NULL == SD->map) {
-	    /* first time */
-	    SD->map = file_map_create(n);
-	} else if (n > SD->map->max_n_files) {
-	    /* it grew, need to expand */
-	    fm = file_map_create(n);
-	    filemapCopy(SD->map, fm);
-	    filemapFreeMemory(SD->map);
-	    SD->map = fm;
-	}
-	/* else it shrunk, and we leave the old one in place */
-    }
-}
-
-void
-storeDirDiskFull(int fn)
-{
-    int dirn = fn >> SWAP_DIR_SHIFT;
-    SwapDir *SD = &Config.cacheSwap.swapDirs[dirn];
-    assert(0 <= dirn && dirn < Config.cacheSwap.n_configured);
-    SD->max_size = SD->cur_size;
-    debug(20, 1) ("WARNING: Shrinking cache_dir #%d to %d KB\n",
-	dirn, SD->cur_size);
-}
Index: squid/src/store_log.c
diff -u squid/src/store_log.c:1.1.1.1 squid/src/store_log.c:1.1.1.1.10.1
--- squid/src/store_log.c:1.1.1.1	Tue Jan 25 19:21:47 2000
+++ squid/src/store_log.c	Fri Nov 10 10:44:53 2000
@@ -66,7 +66,7 @@
 	(int) current_time.tv_sec,
 	(int) current_time.tv_usec / 1000,
 	storeLogTags[tag],
-	e->swap_file_number,
+	e->Sswap_file_number,
 	reply->sline.status,
 	(int) reply->date,
 	(int) reply->last_modified,
